------------------------------------------------------------------
  Releases
------------------------------------------------------------------
v1.2.8  2013.12.12 - kmo_sci_red
                      - Adding the option to apply a fixed velocity offset when reconstructing cubes.
                      - Adding parameter --save_interims which can be used only together with 
                        --no_sky_tweak. Interim reconstructed object and sky cubes are saved to disk as well.
                      - Adding the possibility to subtract skies from objects from different IFUs
                        (using the generated obj_sky_table.txt) 
                   - kmo_std_star
                      - Bug fix: reducing templates with the 3-star configuration produced a
                        segmentation fault 
                   - kmo_wave_cal
                      - Bug fix: in rare cases an error occurred calculating the QC parameters
                        (singular matrix) 
v1.2.7  2013.11.19 - kmo_combine, kmo_sci_red
                      - New additional output frame EXP_MASK: For every combined output
                        frame there is now as well an exposure time mask which indicates
                        for every spatial pixel how many input frames were taken into account
                        for combining. 
                   - kmo_sci_red
                      - Bug fix: "checkerboard pattern" effect: rarely it could happen, that
                        single spaxels at the border of an IFU were spectral misfitted (only
                        with --imethod=CS). This effect normally to be overlooked, has a strong
                        effect when these cobes are combined after reconstruction. Then some kind
                        of checkerboard pattern could emerge in the corners of arbitrary IFUs.
                   - kmo_sci_red, kmo_multi_reconstruct
                      - The object-sky-association table is stored to disk as an intermediate
                        text file. It can be edited to alter the associated skies and then read
                        into the recipe again to apply it.
                   - kmo_combine
                      - Bug fix: when --ifus parameter wasn't defined and if the first IFU wasn't
                        used the recipe would create a segmentation fault
                      - Bug fix: when working with the --ifus parameter, the EXTNAME keyword could
                        get too long and the extension descriptor DATA/NOISE could be cut off. The
                        keyword is now truncated and DATA or NOISE is appended in every case. The
                        same naming convention applies to the craeted filenames (except that
                        DATA/NOISE isn't added).
                   - kmo_std_star
                      - The signal level of the extracted spectrum (in the masked area) is scaled to
                        the same level as the spectrum of the whole IFU (which is used for zeropoint
                        and throughput calculations). The user can now do his own calculations on
                        zeropoint, extracted spectrum etc., since they match now.
                      - New product: NOISE_SPEC (Only generated for data taken with template
                        KMOS_spec_cal_stdstarscipatt) The noise is estimated based on the sky exposures
                        present in all exposures: Skies are subtracted pairwise and reconstructed for
                        every IFU over all exposures. Then the spectra are extracted and for every
                        wavelength point the stddev is calculated and saved 
v1.2.6  2013.10.30 - kmo_illumination_flat
                      - New recipe creating an illumination correction based on FLAT_ON frames.
                   - kmo_reconstruct
                      - Bug fix: wrong calibration angles have been displayed, but the right ones
                        were processed (probably introduced with v1.2.5) 
v1.2.5  2013.10.14 - kmo_flat
                      - Bug fix: Enhanced edge detection taking into account deactivated IFUs which
                        are illuminated quite strongly. 
                   - kmo_multi_reconstruct
                      - Accepts now like kmo_sci_red MASTER_FLAT and OH_SPEC frames, does proper sky
                        subtraction and optionally flux/background calibration. Telluric correction is
                        possible if the objects are on the same IFU for all exposures. Maps can't be reduced.
                   - kmo_sci_red
                      - Bug fix: Object names containing [ or ] couldn't be processed. 
                   - sky_tweak
                      - Bug fix: With continuum missing on one side of the spectrum the code failed.
                   - easySPARK_calibration.sh
                      - The user is not asked anymore if the data should be processed in parallel/serial.
                        This option can be set via a parameter.
                      - After completion of processing a set of tests is executed to ensure integrity of
                        calibration products (easySPARK_test.sh) 
                      - Added version numbers to easySPARK-scripts 
v1.2.4  2013.08.07 - kmo_wave_cal
                      - Bug fix: Sometimes DET_IMG_WAVE product wasn't calculated. 
                   - SPARK-kit installation
                      - Bug fix: On MacOSX compilation of the kit failed. 
v1.2.3  2013.08.02 - kmo_sky_tweak
                      - New, advanced recipe for OH-line subtraction 
                   - kmo_sci_red
                      - Bug fix: When using reflex it happend that only the IFUs containing the std-stars
                        were processed (in v1.2.2 this can be fixed by omitting STD_IMAGE from sof) 
                      - Bug fix: TELLURIC frames generated with data from the 3star-template couldn't be
                        processed if the std-stars weren't at the default IFUs 
                      - Enhanced handling of telluric corrections in general 
                   - kmo_flat
                      - Fix: Due to the corrupted IFU 16, it occured in some FLAT_ON frames that IFU 15 was
                        vignetted strongly and not all edges could be identified. This is detected now and
                        IFU 15 will be omitted. 
                   - kmo_illumination
                      - Bug fix: When data contains IFUs marked as NOTUSED and FLAT_EDGE frame is provided,
                        the recipe just fails without any notice. Without FLAT_EDGE frame the recipe runs through 
                   - kmo_fits_strip
                      - Bug fix: Parameters noise and empty failed on sci_combine-products
                      - Added extension-parameter: Provide absolute extension numbers to strip all other extensions 
                   - kmo_fits_check
                      - Now prints as well the number of empty extensions
                   - kmo_reconstruct, kmo_sci_red, kmo_std_star, kmo_illumination
                      - Increased verbosity on picked calibration frames. Emitting warnings when angles differ
                        too much 
                      - xcal_interpolation is switched off automatically when interval of neighbouring angles is
                        larger than 65deg (for 6 equidistant rotator angles it would be 60deg) 
                   - easySPARK-scripts
                      - Fixed bug: Now the frames needn't anymore be organised in directories with names like
                        YYYY-MM-DD 
                      - Fixed bug: Now the scripts work as well on MacOSX 
v1.2.2  2013.06.29 - reconstruction 
                      - Bug fix: the implementation of xcal_interpolation accidentially marked internally some
                        areas in the calibration frames as bad. Since these areas had a width of 1 pixel, they
                        were just interpolated from the neighbourhood. Now the values are a little bit more
                        correct. 
                      - Bug fix: the implementation of cubic spline (CS) interpolation in the reconstruction of
                        data cubes led from time to time to misfitted spectra, mostly at the borders of the IFUs.
                        Pronounced spectral bell-curves were the result. 
                   - kmo_std_star
                      - Bug fix: Due to the NGC using a wrong data type for CRPIX, CRVAL and CD keywords (integer
                        instead of double) in the RAW frames, no standard stars could be processed. 
v1.2.1  2013.06.20 - Bug fix in kmo_multi_reconstruct
                      - The new calibration format containing multiple angles was ignored processed wrongly. For
                        the calibration frames always the first angle present has been used in the past. 
v1.2.0  2013.06.19 - (release for science verification)
                      - Reference Manual
                         - Updated version. 
v1.1.5  2013.06.05 - (intermediate release)
                      - kmo_sci_red
                         - Bug fix: Failed when OH_SPEC was provided 
                      - reconstruction
                         - No more spikes at the beginning and end of reconstructed spectra (with cubic spline) 
v1.1.4  2013.05.23 - (intermediate release)
                      - kmo_reconstruct, kmo_illumination, kmo_std_star, kmo_sci_red, kmo_shift,
                        kmo_rotate, kmo_combine
                         - Enhancements on flux-conservation. It is switched off as default except in
                           kmo_std_star where we can expect to have a bright object in the IFU. 
                      - kmo_reconstruct
                         - Fixed bug in OH-line matching.
                         - OH-line matching based on a reference OH-spectrum improving object-sky
                           subtraction (like in kmo_reconstruct) 
                      - kmo_sci_red
                         - Enhancements on background-removal for mapping-mode. This feature is off per
                           default since it works best for maps with sparse objects in it.
                         - OH-line matching based on a reference OH-spectrum improving object-sky
                           subtraction (like in kmo_reconstruct) 
                      - kmo_reconstruct, kmo_std_star, kmo_sci_red
                         - Implemented interpolation of xcal-frames for angles in between the frames.
                           This feature is used as default. To switch it off, set the parameter
                           --xcal_interpolation=FALSE 
                      - kmo_make_image
                         - Fixed bug: couldn't collapse a SCI_COMBINED frame. 
                      - RTD
                         - Object- and sky-frame are now first subtracted and then reconstructed
                           (Speed improvement). 
                      - kmo_extract_spec, kmo_make_image, kmo_stats
                         - Fixed bug regarding gasgano: any category for the 1st input frame is accepted now. 
v1.1.3  2013.05.13 - (intermediate release)
                      - kmo_illumination
                         - added --pix_scale parameter for arbitrary pixel resolution in reconstructed cubes 
                      - kmo_reconstruct, kmo_sci_red
                         - Flux of reconstructed cubes is scaled according to pixel_scale 
                      - SPARKplug
                         - Fixed bug: Copying selected frames to lower panel should work now as well on MacOS 
                      - kmo_sci_red
                         - Fixed bug with --no_subtract: Accepts now as well sky-only frames 
                      - easySPARK-scripts
                         - Fixed bugs with ESO archive filename scheme 
v1.1.2  2013.05.08 - (intermediate release)
                      - kmo_combine
                         - Changed default behaviour: if no IFU or name is specified, all target
                           names are combined and saved (no mapping-mode as default anymore) 
                      - kmo_reconstruct
                         - OH-line matching based on a reference OH-spectrum improving object-sky subtraction
                         - added --pix_scale parameter for arbitrary pixel resolution in reconstructed cubes 
                      - kmo_sci_red
                         - added --no_combine option
                         - added --no_subtract option (implies --no_combine because otherwise IFUs
                           containing skies would be combined with ones with objects in it. With kmo_combine
                           the products can be combined individually afterwards)
                         - added --pix_scale parameter for arbitrary pixel resolution in reconstructed cubes
                         - if just a single SCIENCE frame is provided, ALL IFUs (of type R, O and S) are
                           processed 
v.1.1.1  2013.04.23 - (intermediate release)
                      - bug fix:
                         - All recipes doing reconstruction were failing when reading the 
                           calibration frames if angle=0 deg wasn't present 
                      - kmo_std_star
                         - Doesn't crash anymore when star type is defined wrongly in header
                           keywords 
                      - kmo_std_star, kmo_sci_red
                         - Processes now as well R (along with O and S) in header keyword
                           ESO OCS ARMx TYPE 
                      - kmo_combine, kmo_sci_red
                         - Added parameter --edge_nan. Sets top/bottom row to NaN, improves
                           results when dithering (like with SINFONI data). 
                      - kmo_reconstruct, kmo_sci_red
                         - First implementation of improved flux conservation (still to be improved). 
                      - kmo_sci_red
                         - Added parameter --background. Activate for background removal (to be improved). 
v1.1.0  2013.03.19 - (Release for COMM3)
                      - kmo_illumination
                         - Fixed edge effects in ILLUM_CORR. Takes now FLAT_EDGE frame as 
                           input to correlate MASTER_FLAT and FLAT_SKY frames. Additional
                           output SKYFLAT_EDGE. 
                      - kmo_reconstruct, kmo_multi_reconstruct, kmo_illumination, kmo_sci_red
                         - Emit warning if XCAL, YCAL and LCAL frames don't originate from the
                           same calibration set. 
                      -  kmo_sci_red
                         - Emit warning if the parameters b_samples, b_start and b_end aren't
                           the same for LCAL and TELLURIC frames.
v1.0.9  2013.03.13 - intermediate release for USM
                      - kmo_illumination
                          - Ignores now the first exposure of the KMOS_spec_cal_skyflat
                            template which is just for acquisition. With the parameter
                            --add-all it can be forced to be included.
                          - Added band-specific spectral ranges used to collapse the
                            cubes in order to create the skies. 
                      - kmo_std_star
                          - accepts lower case star types
                          - corrected WCS in headers of products
                          - QC THRUPUT and QC ZPOINT are now calculated on the whole area
                            of the IFU and not only on the masked area
                          - QC STD TRACE are now calculated based on the difference of two
                            specified spectral ranges. Before, the whole spectrum was taken
                            into account resulting in inadequate results.
                          - Fixed WCS in product headers as well as EXTNAME keyword which
                            caused errors when processing the products in the next steps 
                      - easySPARK
                          - Fixed bugs in easySPARK_illumination.sh and easySPARK_std_star.sh
                          - Added easySPARK_sci_red.sh 
                      - kmo_sci_red
                          - Increased verbosity on displayed shift parameters
                          - For mapping-mode added --fast-mode parameter for a quick preview
                            based on collapsed cubes
                          - Added telluric tweaking for 3stdstar-template and if 24-template
                            isn't complete 
                      - kmo_combine
                          - Increased verbosity on displayed shift parameters 
                      - kmo_fits_strip
                          - When used with --angle parameter and with calibration files the
                            NAANGLE keywords are now handled correctly
                          - Added parameter --empty to remove empty extensions 
v1.0.8  2013.02.20 - Intermediate release for software developers at USM
                      - kmo_wave_cal'
                         - no BADPIXEL_FLAT frame needed anymore
                         - fixed memory leaks 
                      - Added "file_extension" parameter
                         - If set, the filenames of the products can be
                           altered. The behaviour for the recipes differs:
                            - kmo_arithmetic: provide an arbitrary string to append
                            - kmo_dark: set to TRUE or FALSE to append EXPTIME keyword
                            - kmo_reconstruct: set to TRUE or FALSE to append OBS_ID keyword 
                      - kmo_flat
                         - optimised memory usage, needs now less RAM, a bit
                           slower due to disk I/O 
v1.0.7  2013.01.08 - bugfixes from COMM2 
v1.0.6  2013.01.29    - reduced filesize for calibration files
v1.0.5  2013.01.24    - some intermediate changes, updated ocs-rules
v1.0.4  2013.01.15 - version for COMM2
v1.0.3  2012.11.16    - updated QC SAT, CS interpolation for kmo_std_star
v1.0.2  2012.11.06    - added test-cal-files
v1.0.1  2012.10.31    - bugfix in kmo_multi_reconstruct and kmclipm-tests
v1.0.0  2012.10.23 - version for COMM1
v0.6.7  2012.10.02 - Enhanced gaussfit regarding numerical singularities
                   - fixed bug in kmclipm_vector_combine()
v0.6.6  2012.09.30 - Bug fix: wrong filename for kmos_wave_band.fits
v0.6.5  2012.09.25 - all memory leaks fixed (hopefully)
v0.6.4  2012.09.21 - all memory leaks fixed
v0.6.3  2012.09.14 - before integration at Paranal
v0.6.1  2012.07.11 - fixed tat-tests
v0.6.0  2012.06.27 - runs now with CPL 6.1 (kmclipm as well with CPL 5.3.1)
v0.5.1  2012.06.06 - bugfix for nondest readmode
v0.5.0  2012.06.01 - saturated pixels in nondestructive readmode are handled
v0.4.9  2012.05.22 - before PAE
v0.4.8  fixed 2nd seg. fault problem, patrol-view problem and included all
        issues from v0.4.5
v0.4.6  fixed segmentation problem with RTD
v0.4.5  pre-PAE installation on ICS workstation in Edinburgh
v0.4.1  PAE dry run, follow-up
v0.3.1  Bug fix: kmo_wave_cal worked on MacOS but failed on linux machines
v0.3.0  PAE dry run
v0.2.2  added changes after first experiences with lab data
v0.1.1  reworked code on combining frames
v0.1.0  kmo_reconstruct functional, first version of kmo_combine
v0.0.0  initial developing status
